const config = require( "./config" );

const wrapper = ( ctx ) => value => {
    if( typeof value === "function" )
        return value( wrapper( ctx ) );
    ctx.counter += 1;
    var paramKey = `p_${ctx.counter}`;
    ctx.params[ paramKey ] = value;
    return config.formatFn( paramKey );
};


const auto = ( wrapper ) => ( statics, ... values ) => {
    var buffer = [ statics[0] ];
    for( var [ ix, val ] of Object.entries( values ) ) {
        buffer.push( wrapper( val ) );
        buffer.push( statics[ parseInt( ix ) + 1 ] );
    }
    return buffer.join("");
};

const build = ( fn ) => {
    var ctx = { counter : 0, params : {} };
    var SQL = wrapper( ctx )( fn );
    return [ SQL, ctx.params ];
};

module.exports = { 
    build,
    auto,
    config
};
